#!/bin/ash
# valide-desktop.sh
#
# Purpose : test syntax of *.desktop 
# Please note this is an automated, thus partial, test. You may still miss something! :-)
#
# Dependency (pre-requisite) : install ubuntu package from  
# http://launchpadlibrarian.net/13600299/desktop-file-utils_0.15-1ubuntu3_i386.deb
# on the Puppy to be tested.
#
# musher0, 16 nov. 2013
####
mkdir -p /usr/share/applications.tmp
cd /usr/share/applications
ls -1 *.desktop > /usr/share/applications/liste.dsktp
sleep 1
# Correct Categories
for i in `cat liste.dsktp`; do 
	awk '/^Categories/{$0=$0";";}1' $i > /usr/share/applications.tmp/$i
	sleep 0.1s
done
mkdir -p /usr/share/applications.tmp2
[ "`ls -1 /usr/share/applications.tmp2`" != "" ] && rm -f /usr/share/applications.tmp2/*
cd /usr/share/applications.tmp
ls -1 *.desktop > /usr/share/applications.tmp/liste.dsktp
# Correct MimeTypes
for k in `cat liste.dsktp`; do 
	awk '/^MimeType/{$0=$0";";}1' $k > /usr/share/applications.tmp2/$k
	sleep 0.1s
done
cd /usr/share/applications.tmp2
ls -1 *.desktop > /usr/share/applications.tmp2/liste.dsktp
> /usr/share/applications.tmp2/liste2
for j in `cat liste.dsktp`; do 
	replaceit --input=$j ";;" ; "{MimeType" >/dev/null 2>&1
#	awk '/^MimeType/{$0=$0";;";}1' $j > /usr/share/applications.tmp2/$j
 	sleep 0.2s
	desktop-file-validate --no-warn-deprecated $j >> /usr/share/applications.tmp2/liste2
#	echo >> /usr/share/applications.tmp2/liste2
done
#
# disregard "icon name" errors, special "X-" Puppy categories, 
# KDE specific entries and semicolons
grep -v "icon name" /usr/share/applications.tmp2/liste2 | grep -v "X-" | grep -v KDE | grep -v semicolon > /usr/share/applications.tmp2/liste3
# and blank lines # grep -v '^$' 
sleep 0.1s
# The report file is now ready to be read by the user.
defaulttexteditor /usr/share/applications.tmp2/liste3
# Comment:
# The "liste3" file  should now list only "faulty" or incomplete *.desktop files.
# Decide at this point to edit or not the *.desktop files in /usr/share/applications
# according to the suggestions in the report.
#
# Re-run this script until you get no errors in the "liste3" report. 
#
# Once satisfied with the results, delete the /usr/share/applications.tmp2 folder.
# 
# Script clean-up
rm -f  /usr/share/applications.tmp/*
rmdir /usr/share/applications.tmp
rm -f  /usr/share/applications/liste.*
rm -f /usr/share/applications.tmp/liste.*
# 30 #
